searchNodes=[{"ref":"Matrax.html","title":"Matrax","type":"module","doc":"A matrix library in pure Elixir based on atomics. Erlang atomics documentation Key features: concurrent accessibility: atomics are mutable and can be accessed from multiple processes access path only transofrmations: transformations like transpose change only the access path so the same matrix can be worked on in multiple states by different processes at the same time fast accessibility: operations like get/2 and put/3 are very fast and based only on pure Elixir Examples iex&gt; matrax = Matrax.new(100, 100) # 100 x 100 matrix iex&gt; matrax |&gt; Matrax.put({0, 0}, 10) # add 10 to position {0, 0} iex&gt; matrax |&gt; Matrax.get({0, 0}) 10 iex&gt; matrax |&gt; Matrax.add({0, 0}, 80) iex&gt; matrax |&gt; Matrax.get({0, 0}) 90 Enumerable protocol Matrax implements the Enumerable protocol, so all Enum functions can be used: iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.put({0, 0}, 8) iex&gt; matrax |&gt; Enum.max() 8 iex&gt; matrax |&gt; Enum.member?(7) false"},{"ref":"Matrax.html#add/2","title":"Matrax.add/2","type":"function","doc":"Adds a list of matrices to matrax. Size (rows, columns) of matrices must match. Returns :ok. Examples iex&gt; matrax = Matrax.new(5, 5) iex&gt; matrax7 = Matrax.new(5, 5, seed_fun: fn _ -&gt; 7 end) iex&gt; matrax |&gt; Matrax.get({0, 0}) 0 iex&gt; matrax |&gt; Matrax.add([matrax7, matrax7]) iex&gt; matrax |&gt; Matrax.get({0, 0}) 14 iex&gt; matrax |&gt; Matrax.add([matrax7]) iex&gt; matrax |&gt; Matrax.get({0, 0}) 21"},{"ref":"Matrax.html#add/3","title":"Matrax.add/3","type":"function","doc":"Adds incr to atomic at position. Returns :ok. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.add({0, 0}, 2) :ok iex&gt; matrax |&gt; Matrax.add({0, 0}, 2) :ok iex&gt; matrax |&gt; Matrax.get({0, 0}) 4"},{"ref":"Matrax.html#add_get/3","title":"Matrax.add_get/3","type":"function","doc":"Atomic addition and return of the result. Adds incr to atomic at position and returns result. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.add_get({0, 0}, 2) 2 iex&gt; matrax |&gt; Matrax.add_get({0, 0}, 2) 4"},{"ref":"Matrax.html#apply/2","title":"Matrax.apply/2","type":"function","doc":"Applies the given fun function to all elements of matrax. If arity of fun is 1 it receives the integer as single argument. If arity of fun is 2 it receives the integer as first and position tuple as the second argument. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.apply(fn int -&gt; int + 2 end) iex&gt; matrax |&gt; Matrax.get({0, 0}) 2 iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.apply(fn _int, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.get({9, 9}) 81"},{"ref":"Matrax.html#argmax/1","title":"Matrax.argmax/1","type":"function","doc":"Returns position tuple of biggest value. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.argmax() {4, 4} iex&gt; matrax = Matrax.new(5, 5) # all zeros iex&gt; matrax |&gt; Matrax.argmax() {0, 0}"},{"ref":"Matrax.html#argmin/1","title":"Matrax.argmin/1","type":"function","doc":"Returns position tuple of smallest value. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.argmin() {0, 0} iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; -(row * col) end) iex&gt; matrax |&gt; Matrax.argmin() {4, 4}"},{"ref":"Matrax.html#clear_changes/1","title":"Matrax.clear_changes/1","type":"function","doc":"Clears all changes made to %Matrax{} struct by setting the :changes key to [] and reverting its modifications to :rows &amp; :columns. Clears access path only modifications like transpose/1 but not modifications to integer values in the :atomics. Examples iex&gt; matrax = Matrax.identity(3) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [1, 0, 0], [0, 1, 0], [0, 0, 1] ] iex&gt; matrax = matrax |&gt; Matrax.diagonal() iex&gt; matrax |&gt; Matrax.apply(fn _ -&gt; 8 end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [[8, 8, 8]] iex&gt; matrax = matrax |&gt; Matrax.column(0) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [[8]] iex&gt; matrax = matrax |&gt; Matrax.clear_changes() iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [8, 0, 0], [0, 8, 0], [0, 0, 8] ]"},{"ref":"Matrax.html#clear_last_change/1","title":"Matrax.clear_last_change/1","type":"function","doc":"Clears last change made to %Matrax{} struct by removing the head of :changes key and reverting its modifications to :rows &amp; :columns. Clears access path only modifications like transpose/1 but not modifications to integer values in the :atomics. Examples iex&gt; matrax = Matrax.identity(3) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [1, 0, 0], [0, 1, 0], [0, 0, 1] ] iex&gt; matrax = matrax |&gt; Matrax.diagonal() iex&gt; matrax |&gt; Matrax.apply(fn _ -&gt; 8 end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [[8, 8, 8]] iex&gt; matrax = matrax |&gt; Matrax.clear_last_change() iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [8, 0, 0], [0, 8, 0], [0, 0, 8] ]"},{"ref":"Matrax.html#column/2","title":"Matrax.column/2","type":"function","doc":"Only modifies the struct, it doesn&#39;t move or mutate data. Reduces matrix to only one column at given column index. After column/2 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {_row, col} -&gt; col end) iex&gt; matrax |&gt; Matrax.column(4) |&gt; Matrax.to_list_of_lists [[4], [4], [4], [4], [4]]"},{"ref":"Matrax.html#column_to_list/2","title":"Matrax.column_to_list/2","type":"function","doc":"Converts given column index of %Matrax{} to list. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.column_to_list(2) [0, 2, 4, 6, 8]"},{"ref":"Matrax.html#compare_exchange/4","title":"Matrax.compare_exchange/4","type":"function","doc":"Atomically compares the value at position with expected , and if those are equal, sets value at position to desired. Returns :ok if desired was written. Returns the actual value at position if it does not equal to desired. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.compare_exchange({0, 0}, 0, -10) :ok iex&gt; matrax |&gt; Matrax.compare_exchange({0, 0}, 3, 10) -10"},{"ref":"Matrax.html#concat/3","title":"Matrax.concat/3","type":"function","doc":"Concatenates a list of %Matrax{} matrices. Returns a new %Matrax{} struct with a new atomics reference containing all values of matrices from list. Options :signed - (boolean) to have signed or unsigned 64bit integers in the new matrix. Defaults to true. Examples iex&gt; matrax = Matrax.new(3, 3, seed_fun: fn _, {_row, col} -&gt; col end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 1, 2], [0, 1, 2], [0, 1, 2] ] iex&gt; Matrax.concat([matrax, matrax], :rows) |&gt; Matrax.to_list_of_lists() [ [0, 1, 2], [0, 1, 2], [0, 1, 2], [0, 1, 2], [0, 1, 2], [0, 1, 2] ] iex&gt; Matrax.concat([matrax, matrax], :columns) |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 0, 1, 2], [0, 1, 2, 0, 1, 2], [0, 1, 2, 0, 1, 2] ]"},{"ref":"Matrax.html#copy/1","title":"Matrax.copy/1","type":"function","doc":"Returns a %Matrax{} struct with a new atomics reference and positional values identical to the given matrax. The returned copy is always changes: [] so this can be used to finish the access-path only changes by the transpose/1, submatrix/3, reshape/3 functions. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.put({0, 0}, -9) iex&gt; matrax2 = Matrax.copy(matrax) iex&gt; Matrax.get(matrax2, {0, 0}) -9"},{"ref":"Matrax.html#count/1","title":"Matrax.count/1","type":"function","doc":"Returns count of values (rows * columns). Examples iex&gt; matrax = Matrax.new(5, 5) iex&gt; Matrax.count(matrax) 25"},{"ref":"Matrax.html#diagonal/1","title":"Matrax.diagonal/1","type":"function","doc":"Only modifies the struct, it doesn&#39;t move or mutate data. After diagonal/1 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.identity(5) iex&gt; matrax |&gt; Matrax.diagonal() |&gt; Matrax.to_list_of_lists [[1, 1, 1, 1, 1]]"},{"ref":"Matrax.html#drop_column/2","title":"Matrax.drop_column/2","type":"function","doc":"Drops column of matrix at given column_index. Only modifies the struct, it doesn&#39;t move or mutate data. After drop_column/2 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(4, 5, seed_fun: fn _, {_row, col} -&gt; col end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 3, 4], [0, 1, 2, 3, 4], [0, 1, 2, 3, 4], [0, 1, 2, 3, 4], ] iex&gt; matrax |&gt; Matrax.drop_column(1) |&gt; Matrax.to_list_of_lists() [ [0, 2, 3, 4], [0, 2, 3, 4], [0, 2, 3, 4], [0, 2, 3, 4], ]"},{"ref":"Matrax.html#drop_row/2","title":"Matrax.drop_row/2","type":"function","doc":"Drops row of matrix at given row_index. Only modifies the struct, it doesn&#39;t move or mutate data. After drop_row/2 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(5, 4, seed_fun: fn _, {row, _col} -&gt; row end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 0, 0, 0], [1, 1, 1, 1], [2, 2, 2, 2], [3, 3, 3, 3], [4, 4, 4, 4], ] iex&gt; matrax |&gt; Matrax.drop_row(1) |&gt; Matrax.to_list_of_lists() [ [0, 0, 0, 0], [2, 2, 2, 2], [3, 3, 3, 3], [4, 4, 4, 4], ]"},{"ref":"Matrax.html#exchange/3","title":"Matrax.exchange/3","type":"function","doc":"Atomically replaces value at position with value and returns the value it had before. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.exchange({0, 0}, -10) 0 iex&gt; matrax |&gt; Matrax.exchange({0, 0}, -15) -10"},{"ref":"Matrax.html#find/2","title":"Matrax.find/2","type":"function","doc":"Returns position of the first occurence of the given value or nil if nothing was found. Examples iex&gt; Matrax.new(5, 5) |&gt; Matrax.find(0) {0, 0} iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.find(16) {4, 4} iex&gt; matrax |&gt; Matrax.find(42) nil"},{"ref":"Matrax.html#flip_lr/1","title":"Matrax.flip_lr/1","type":"function","doc":"Flip columns of matrix in the left-right direction (vertical axis). After flip_lr/1 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(3, 4, seed_fun: fn _, {_row, col} -&gt; col end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 3], [0, 1, 2, 3], [0, 1, 2, 3] ] iex&gt; matrax |&gt; Matrax.flip_lr() |&gt; Matrax.to_list_of_lists() [ [3, 2, 1, 0], [3, 2, 1, 0], [3, 2, 1, 0] ]"},{"ref":"Matrax.html#flip_ud/1","title":"Matrax.flip_ud/1","type":"function","doc":"Flip rows of matrix in the up-down direction (horizontal axis). After flip_ud/1 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(3, 4, seed_fun: fn _, {row, _col} -&gt; row end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 0, 0, 0], [1, 1, 1, 1], [2, 2, 2, 2] ] iex&gt; matrax |&gt; Matrax.flip_ud() |&gt; Matrax.to_list_of_lists() [ [2, 2, 2, 2], [1, 1, 1, 1], [0, 0, 0, 0] ]"},{"ref":"Matrax.html#get/2","title":"Matrax.get/2","type":"function","doc":"Returns value at position from the given matrax. Examples iex&gt; matrax = Matrax.new(10, 10, seed_fun: fn _ -&gt; 3 end) iex&gt; matrax |&gt; Matrax.get({0, 5}) 3"},{"ref":"Matrax.html#identity/1","title":"Matrax.identity/1","type":"function","doc":"Create identity square matrix of given size. Examples iex&gt; Matrax.identity(5) |&gt; Matrax.to_list_of_lists [ [1, 0, 0, 0, 0], [0, 1, 0, 0, 0], [0, 0, 1, 0, 0], [0, 0, 0, 1, 0], [0, 0, 0, 0, 1] ]"},{"ref":"Matrax.html#index_to_position/2","title":"Matrax.index_to_position/2","type":"function","doc":"Returns a position tuple for the given atomics index. Indices of atomix are 1 based. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; Matrax.index_to_position(matrax, 1) {0, 0} iex&gt; Matrax.index_to_position(matrax, 10) {0, 9}"},{"ref":"Matrax.html#max/1","title":"Matrax.max/1","type":"function","doc":"Returns largest integer in matrax. Examples iex&gt; matrax = Matrax.new(10, 10, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.max() 81 iex&gt; Matrax.new(5, 5) |&gt; Matrax.max() 0"},{"ref":"Matrax.html#member?/2","title":"Matrax.member?/2","type":"function","doc":"Checks if value exists within matrax. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.member?(6) true iex&gt; matrax |&gt; Matrax.member?(100) false"},{"ref":"Matrax.html#min/1","title":"Matrax.min/1","type":"function","doc":"Returns smallest integer in matrax. Examples iex&gt; matrax = Matrax.new(10, 10, seed_fun: fn _ -&gt; 7 end) iex&gt; matrax |&gt; Matrax.min() 7"},{"ref":"Matrax.html#new/1","title":"Matrax.new/1","type":"function","doc":"Converts an integer list_of_lists to a new %Matrax{} struct. Same as new/2 without options. Examples iex&gt; matrax = %Matrax{rows: 2, columns: 3} = Matrax.new([[1,2,3], [4, 5, 6]]) iex&gt; matrax |&gt; Matrax.to_list_of_lists [[1,2,3], [4, 5, 6]]"},{"ref":"Matrax.html#new/2","title":"Matrax.new/2","type":"function","doc":"Converts a list_of_lists to a new %Matrax{} struct. Options :signed - (boolean) to have signed or unsigned 64bit integers. Defaults to true. Examples iex&gt; matrax = %Matrax{rows: 2, columns: 3} = Matrax.new([[1,2,3], [4, 5, 6]], signed: false) iex&gt; matrax |&gt; Matrax.to_list_of_lists [[1,2,3], [4, 5, 6]] iex&gt; matrax |&gt; Matrax.count 6"},{"ref":"Matrax.html#new/3","title":"Matrax.new/3","type":"function","doc":"Returns a new %Matrax{} struct with the given rows and columns size. Options :seed_fun - (function) a function to seed all positions. See apply/2 for further information. :signed - (boolean) to have signed or unsigned 64bit integers. Defaults to true. Examples Matrax.new(10, 5) # 10 x 5 matrix Matrax.new(10, 5, signed: false) # unsigned integers Matrax.new(10, 5, seed_fun: fn _, {row, col} -&gt; row * col end) # seed values"},{"ref":"Matrax.html#position_to_index/2","title":"Matrax.position_to_index/2","type":"function","doc":"Returns atomics index corresponding to the position tuple in the given %Matrax{} struct. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.position_to_index({1, 1}) 12 iex&gt; matrax |&gt; Matrax.position_to_index({0, 4}) 5"},{"ref":"Matrax.html#put/3","title":"Matrax.put/3","type":"function","doc":"Puts value into matrax at position. Returns :ok Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.put({1, 3}, 5) :ok"},{"ref":"Matrax.html#reshape/3","title":"Matrax.reshape/3","type":"function","doc":"Reshapes matrax to the given rows &amp; cols. After reshape/3 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(4, 3, seed_fun: fn _, {_row, col} -&gt; col end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 1, 2], [0, 1, 2], [0, 1, 2], [0, 1, 2] ] iex&gt; matrax |&gt; Matrax.reshape(2, 6) |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 0, 1, 2], [0, 1, 2, 0, 1, 2] ]"},{"ref":"Matrax.html#row/2","title":"Matrax.row/2","type":"function","doc":"Only modifies the struct, it doesn&#39;t move or mutate data. Reduces matrix to only one row at given row index. After row/2 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, _col} -&gt; row end) iex&gt; matrax |&gt; Matrax.row(4) |&gt; Matrax.to_list_of_lists [[4, 4, 4, 4, 4]]"},{"ref":"Matrax.html#row_to_list/2","title":"Matrax.row_to_list/2","type":"function","doc":"Converts given row index of %Matrax{} to list. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.row_to_list(2) [0, 2, 4, 6, 8]"},{"ref":"Matrax.html#set_column/3","title":"Matrax.set_column/3","type":"function","doc":"Set column of a matrix at column_index to the values from the given 1-column matrix. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _ -&gt; 1 end) iex&gt; column_matrax = Matrax.new(5, 1, seed_fun: fn _ -&gt; 3 end) iex&gt; Matrax.set_column(matrax, 2, column_matrax) |&gt; Matrax.to_list_of_lists [ [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], [1, 1, 3, 1, 1], ]"},{"ref":"Matrax.html#set_row/3","title":"Matrax.set_row/3","type":"function","doc":"Set row of a matrix at row_index to the values from the given 1-row matrix. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _ -&gt; 1 end) iex&gt; row_matrax = Matrax.new(1, 5, seed_fun: fn _ -&gt; 3 end) iex&gt; Matrax.set_row(matrax, 2, row_matrax) |&gt; Matrax.to_list_of_lists [ [1, 1, 1, 1, 1], [1, 1, 1, 1, 1], [3, 3, 3, 3, 3], [1, 1, 1, 1, 1], [1, 1, 1, 1, 1], ]"},{"ref":"Matrax.html#sub/2","title":"Matrax.sub/2","type":"function","doc":"Subtracts a list of matrices from matrax. Size (rows, columns) of matrices must match. Returns :ok. Examples iex&gt; matrax = Matrax.new(5, 5) iex&gt; matrax7 = Matrax.new(5, 5, seed_fun: fn _ -&gt; 7 end) iex&gt; matrax |&gt; Matrax.get({0, 0}) 0 iex&gt; matrax |&gt; Matrax.sub([matrax7, matrax7]) iex&gt; matrax |&gt; Matrax.get({0, 0}) -14 iex&gt; matrax |&gt; Matrax.sub([matrax7]) iex&gt; matrax |&gt; Matrax.get({0, 0}) -21"},{"ref":"Matrax.html#sub/3","title":"Matrax.sub/3","type":"function","doc":"Subtracts decr from atomic at position. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.sub({0, 0}, 1) :ok iex&gt; matrax |&gt; Matrax.sub({0, 0}, 1) :ok iex&gt; matrax |&gt; Matrax.get({0, 0}) -2"},{"ref":"Matrax.html#sub_get/3","title":"Matrax.sub_get/3","type":"function","doc":"Atomic subtraction and return of the result. Subtracts decr from atomic at position and returns result. Examples iex&gt; matrax = Matrax.new(10, 10) iex&gt; matrax |&gt; Matrax.sub_get({0, 0}, 2) -2 iex&gt; matrax |&gt; Matrax.sub_get({0, 0}, 2) -4"},{"ref":"Matrax.html#submatrix/3","title":"Matrax.submatrix/3","type":"function","doc":"Only modifies the struct, it doesn&#39;t move or mutate data. Ranges are inclusive. After submatrix/3 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(7, 4, seed_fun: fn _, {row, col} -&gt; row + col end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 3], [1, 2, 3, 4], [2, 3, 4, 5], [3, 4, 5, 6], [4, 5, 6, 7], [5, 6, 7, 8], [6, 7, 8, 9] ] iex&gt; matrax |&gt; Matrax.submatrix(5..6, 1..3) |&gt; Matrax.to_list_of_lists() [ [6, 7, 8], [7, 8, 9] ]"},{"ref":"Matrax.html#sum/1","title":"Matrax.sum/1","type":"function","doc":"Returns sum of integers in matrax. Examples iex&gt; matrax = Matrax.new(10, 10, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; matrax |&gt; Matrax.sum() 2025 iex&gt; Matrax.new(5, 5, seed_fun: fn _ -&gt; 1 end) |&gt; Matrax.sum() 25"},{"ref":"Matrax.html#to_list/1","title":"Matrax.to_list/1","type":"function","doc":"Converts %Matrax{} to a flat list. Examples iex&gt; matrax = Matrax.new(3, 3, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; Matrax.to_list(matrax) [0, 0, 0, 0, 1, 2, 0, 2, 4]"},{"ref":"Matrax.html#to_list_of_lists/1","title":"Matrax.to_list_of_lists/1","type":"function","doc":"Converts %Matrax{} to list of lists. Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _, {row, col} -&gt; row * col end) iex&gt; Matrax.to_list_of_lists(matrax) [ [0, 0, 0, 0, 0], [0, 1, 2, 3, 4], [0, 2, 4, 6, 8], [0, 3, 6, 9, 12], [0, 4, 8, 12, 16] ]"},{"ref":"Matrax.html#trace/1","title":"Matrax.trace/1","type":"function","doc":"Trace of matrix (sum of all diagonal elements). Examples iex&gt; matrax = Matrax.new(5, 5, seed_fun: fn _ -&gt; 1 end) iex&gt; matrax |&gt; Matrax.trace() 5"},{"ref":"Matrax.html#transpose/1","title":"Matrax.transpose/1","type":"function","doc":"Only modifies the struct, it doesn&#39;t move or mutate data. After transpose/1 the access path to positions will be modified during execution. If you want to get a new :atomics with mofified data use the copy/1 function which applies the :changes. Examples iex&gt; matrax = Matrax.new(7, 4, seed_fun: fn _, {row, col} -&gt; row + col end) iex&gt; matrax |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 3], [1, 2, 3, 4], [2, 3, 4, 5], [3, 4, 5, 6], [4, 5, 6, 7], [5, 6, 7, 8], [6, 7, 8, 9] ] iex&gt; matrax |&gt; Matrax.transpose() |&gt; Matrax.to_list_of_lists() [ [0, 1, 2, 3, 4, 5, 6], [1, 2, 3, 4, 5, 6, 7], [2, 3, 4, 5, 6, 7, 8], [3, 4, 5, 6, 7, 8, 9] ]"},{"ref":"Matrax.html#t:position/0","title":"Matrax.position/0","type":"type","doc":""},{"ref":"Matrax.html#t:t/0","title":"Matrax.t/0","type":"type","doc":""}]